
//
//  rbg}bvǂݍ g.koutaki 2012
//

#include "bmp_loader.h"
//#include <windows.h>


void load_bmp_gray(char *filename, unsigned char **img, int *w, int *h){

	FILE *fp=fopen(filename, "rb");
	BITMAPINFOHEADER BmpInfoH;
	BITMAPFILEHEADER BmpFileH;
	int x, y, pitch;
	unsigned char line[3*9096];
	int s = sizeof(BITMAPINFOHEADER);
	
	if(fp){
		fread(&BmpFileH, 1, 14, fp);
		fread(&BmpInfoH, 1, 40, fp);
		printf("%d %d\n", sizeof(BmpFileH), sizeof(BmpInfoH));
		//@rbg}bv̕߂
		*w=BmpInfoH.biWidth;
		*h=BmpInfoH.biHeight;
		printf("load %s:%dx%d\n", filename, *w, *h);
		(*img) = new unsigned char[*w * *h];
		pitch = (*w * 3 + 3) & ~3;
		//rbg}bvf[^܂Ńt@C|Cgړ
		fseek(fp, 54, SEEK_SET);
		if(BmpInfoH.biBitCount == 24)
		{
			// (0.299 * R + 0.587 * G + 0.114 * B)
		for(y = *h-1; y >= 0 ;y--){
			fread(line, pitch, 1, fp);
			for(x = 0;x < *w; x++){
//				(*img)[x + y * *w] = min(max((line[x * 3] +  line[x * 3 + 1] +  line[x * 3 + 2]) / 3, 0), 255);
				(*img)[x + y * *w] = min(max(0.299 * line[x * 3] +  0.587 * line[x * 3 + 1] +  0.114 * line[x * 3 + 2], 0), 255);
			};
		};
		} else {
		for(y = *h-1; y >= 0 ;y--){
			fread(line, pitch, 1, fp);
			for(x = 0;x < *w; x++){
				(*img)[x + y * *w] = line[x];	// R
			};
		};			
		}
		fclose(fp);
	};
};


void write_bmp_gray(char *filename, unsigned char *img, int w, int h){

	FILE *fp=fopen(filename, "wb");
	BITMAPINFOHEADER BmpInfoH;
	BITMAPINFO		 BmpInfo;
	BITMAPFILEHEADER BmpFileH;
	int x, y, pitch;
	unsigned char line[3*9096];
	int s = sizeof(BITMAPFILEHEADER);
	
	if(fp){
		//@rbg}bv̕߂
		pitch = (w * 3 + 3) & ~3;
		memset(&BmpFileH, 0, 14);
		memset(&BmpInfo,  0, 40);
		memset(&BmpInfoH, 0, 40);
		BmpInfo.bmiHeader.biHeight = h;
		BmpInfo.bmiHeader.biWidth = w;
		BmpInfo.bmiHeader.biSize = 40;
		BmpInfo.bmiHeader.biSizeImage = pitch * h;
		BmpInfo.bmiHeader.biPlanes = 1;
		BmpInfo.bmiHeader.biBitCount = 24;
		BmpInfo.bmiHeader.biCompression  = 0;
		BmpInfo.bmiHeader.biClrUsed = 0;
		BmpInfo.bmiHeader.biXPelsPerMeter = 3780;
		BmpInfo.bmiHeader.biYPelsPerMeter = 3780;
		BmpInfo.bmiHeader.biClrImportant = 0;
		BmpInfoH = BmpInfo.bmiHeader;
		BmpFileH.bfOffBits = 54;
		BmpFileH.bfSize = pitch * h + BmpFileH.bfOffBits;
		BmpFileH.bfType = 19778;
		BmpFileH.bfReserved1 = 0;
		BmpFileH.bfReserved2 = 0;
		printf("write %s:%dx%d\n", filename, w, h);

        char c1,c2;
        c1 ='B';
        c2 = 'M';
        
		fwrite(&c1, 1, 1, fp);
		fwrite(&c2, 1, 1, fp);
		fwrite(&BmpFileH.bfSize, 4, 1, fp);
		fwrite(&BmpFileH.bfReserved1, 2, 1, fp);
		fwrite(&BmpFileH.bfReserved1, 2, 1, fp);
		fwrite(&BmpFileH.bfOffBits, 4, 1, fp);
        
        
        fwrite(&BmpInfoH.biSize, 40, 4, fp);
        fwrite(&BmpInfoH.biWidth, 40, 4, fp);
        fwrite(&BmpInfoH.biHeight, 40, 4, fp);
        fwrite(&BmpInfoH.biPlanes, 40, 2, fp);
        fwrite(&BmpInfoH.biBitCount, 40, 2, fp);
        fwrite(&BmpInfoH.biCompression, 40, 4, fp);
        fwrite(&BmpInfoH.biSizeImage, 40, 4, fp);
        fwrite(&BmpInfoH.biXPelsPerMeter, 40, 4, fp);
        fwrite(&BmpInfoH.biYPelsPerMeter, 40, 4, fp);
        fwrite(&BmpInfoH.biClrUsed, 40, 4, fp);
        fwrite(&BmpInfoH.biClrImportant, 40, 4, fp);
 
        fseek(fp, 54, SEEK_SET);
 
		for(y = h - 1; y >= 0;y--){
			for(x = 0;x < w; x++){
				line[x * 3+2] = img[(x + y * w)];
				line[x * 3+1] = img[(x + y * w)];
				line[x * 3+0] = img[(x + y * w)];
			};
			fwrite(line, pitch, 1, fp);
		};
		fclose(fp);
	};
};



